# frozen_string_literal: true

module DrgDSL
  # Add core extensions here as refinements. Only load them when necessary, so
  # that we don't monkeypatch applications that load DrgDSL.
  #
  # @example Loading the core extensions to the current lexical scope
  #
  #   module MyScope
  #     using DrgDSL::CoreExtensions
  #
  #     # Extensions exist here
  #
  #   end
  #
  #   # Extensions no longer exist here
  #
  module CoreExtensions
    refine String do
      def colorize(color_code)
        "\e[#{color_code}m#{self}\e[0m"
      end

      def magenta
        colorize 35
      end

      def cyan
        colorize 36
      end

      def red
        colorize 31
      end

      def yellow
        colorize 33
      end

      def green
        colorize 32
      end

      def blue
        colorize 34
      end
    end
  end
end
